Ruby: rb_objspace Struct Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Data Fields
rb_objspace Struct Reference

## Data Fields
struct {
size_t limit
size_t increase
} | malloc_params
struct {
unsigned int mode: 2
unsigned int immediate_sweep: 1
unsigned int dont_gc: 1
unsigned int dont_incremental: 1
unsigned int during_gc: 1
unsigned int during_compacting: 1
unsigned int gc_stressful: 1
unsigned int has_hook: 1
unsigned int during_minor_gc: 1
} | flags
rb_event_flag_t | hook_events
size_t | total_allocated_objects
VALUE | next_object_id
rb_heap_t | eden_heap
rb_heap_t | tomb_heap
struct {
rb_atomic_t finalizing
} | atomic_flags
mark_stack_t | mark_stack
size_t | marked_slots
struct {
struct heap_page ** sorted
size_t allocated_pages
size_t allocatable_pages
size_t sorted_length
RVALUE * range [2]
size_t freeable_pages
size_t final_slots
VALUE deferred_final
} | heap_pages
st_table * | finalizer_table
struct {
int run
int latest_gc_info
gc_profile_record * records
gc_profile_record * current_record
size_t next_index
size_t size
double invoke_time
size_t minor_gc_count
size_t major_gc_count
size_t compact_count
size_t read_barrier_faults
double gc_sweep_start_time
size_t total_allocated_objects_at_gc_start
size_t heap_used_at_gc_start
size_t count
size_t total_freed_objects
size_t total_allocated_pages
size_t total_freed_pages
} | profile
struct gc_list * | global_list
VALUE | gc_stress_mode
struct {
VALUE parent_object
int need_major_gc
size_t last_major_gc
size_t uncollectible_wb_unprotected_objects
size_t uncollectible_wb_unprotected_objects_limit
size_t old_objects
size_t old_objects_limit
} | rgengc
struct {
size_t considered_count_table [T_MASK]
size_t moved_count_table [T_MASK]
size_t total_moved
} | rcompactor
st_table * | id_to_obj_tbl
st_table * | obj_to_id_tbl

## Detailed Description

Definition at line 666 of file gc.c.

## Field Documentation

## ◆ allocatable_pages

size_t rb_objspace::allocatable_pages

Definition at line 708 of file gc.c.

## ◆ allocated_pages

size_t rb_objspace::allocated_pages

Definition at line 707 of file gc.c.

## ◆

struct { ... } rb_objspace::atomic_flags

## ◆ compact_count

size_t rb_objspace::compact_count

Definition at line 735 of file gc.c.

## ◆ considered_count_table

size_t rb_objspace::considered_count_table[T_MASK]

Definition at line 791 of file gc.c.

## ◆ count

size_t rb_objspace::count

Definition at line 761 of file gc.c.

Referenced by rb_gc_count().

## ◆ current_record

gc_profile_record* rb_objspace::current_record

Definition at line 724 of file gc.c.

## ◆ deferred_final

VALUE rb_objspace::deferred_final

Definition at line 715 of file gc.c.

## ◆ dont_gc

unsigned int rb_objspace::dont_gc

Definition at line 679 of file gc.c.

## ◆ dont_incremental

unsigned int rb_objspace::dont_incremental

Definition at line 680 of file gc.c.

Referenced by rb_objspace_call_finalizer().

## ◆ during_compacting

unsigned int rb_objspace::during_compacting

Definition at line 682 of file gc.c.

## ◆ during_gc

unsigned int rb_objspace::during_gc

Definition at line 681 of file gc.c.

## ◆ during_minor_gc

unsigned int rb_objspace::during_minor_gc

Definition at line 685 of file gc.c.

## ◆ eden_heap

rb_heap_t rb_objspace::eden_heap

Definition at line 695 of file gc.c.

Referenced by rb_objspace_alloc(), and rb_objspace_free().

## ◆ final_slots

size_t rb_objspace::final_slots

Definition at line 714 of file gc.c.

## ◆ finalizer_table

st_table* rb_objspace::finalizer_table

Definition at line 718 of file gc.c.

## ◆ finalizing

rb_atomic_t rb_objspace::finalizing

Definition at line 699 of file gc.c.

## ◆

struct { ... } rb_objspace::flags

Referenced by rb_objspace_call_finalizer(), and rb_objspace_set_event_hook().

## ◆ freeable_pages

size_t rb_objspace::freeable_pages

Definition at line 711 of file gc.c.

## ◆ gc_stress_mode

VALUE rb_objspace::gc_stress_mode

Definition at line 768 of file gc.c.

## ◆ gc_stressful

unsigned int rb_objspace::gc_stressful

Definition at line 683 of file gc.c.

## ◆ gc_sweep_start_time

double rb_objspace::gc_sweep_start_time

Definition at line 756 of file gc.c.

## ◆ global_list

struct gc_list* rb_objspace::global_list

Definition at line 766 of file gc.c.

## ◆ has_hook

unsigned int rb_objspace::has_hook

Definition at line 684 of file gc.c.

Referenced by rb_objspace_set_event_hook().

## ◆

struct { ... } rb_objspace::heap_pages

## ◆ heap_used_at_gc_start

size_t rb_objspace::heap_used_at_gc_start

Definition at line 758 of file gc.c.

## ◆ hook_events

rb_event_flag_t rb_objspace::hook_events

Definition at line 691 of file gc.c.

Referenced by rb_objspace_set_event_hook().

## ◆ id_to_obj_tbl

st_table* rb_objspace::id_to_obj_tbl

Definition at line 803 of file gc.c.

Referenced by Init_heap(), and rb_objspace_free().

## ◆ immediate_sweep

unsigned int rb_objspace::immediate_sweep

Definition at line 678 of file gc.c.

## ◆ increase

size_t rb_objspace::increase

Definition at line 669 of file gc.c.

## ◆ invoke_time

double rb_objspace::invoke_time

Definition at line 731 of file gc.c.

Referenced by Init_heap().

## ◆ last_major_gc

size_t rb_objspace::last_major_gc

Definition at line 773 of file gc.c.

## ◆ latest_gc_info

int rb_objspace::latest_gc_info

Definition at line 722 of file gc.c.

## ◆ limit

size_t rb_objspace::limit

Definition at line 668 of file gc.c.

## ◆ major_gc_count

size_t rb_objspace::major_gc_count

Definition at line 734 of file gc.c.

## ◆

struct { ... } rb_objspace::malloc_params

## ◆ mark_stack

mark_stack_t rb_objspace::mark_stack

Definition at line 702 of file gc.c.

Referenced by Init_heap(), rb_gc_force_recycle(), and rb_objspace_free().

## ◆ marked_slots

size_t rb_objspace::marked_slots

Definition at line 703 of file gc.c.

## ◆ minor_gc_count

size_t rb_objspace::minor_gc_count

Definition at line 733 of file gc.c.

## ◆ mode

unsigned int rb_objspace::mode

Definition at line 677 of file gc.c.

## ◆ moved_count_table

size_t rb_objspace::moved_count_table[T_MASK]

Definition at line 792 of file gc.c.

## ◆ need_major_gc

int rb_objspace::need_major_gc

Definition at line 772 of file gc.c.

## ◆ next_index

size_t rb_objspace::next_index

Definition at line 725 of file gc.c.

## ◆ next_object_id

VALUE rb_objspace::next_object_id

Definition at line 693 of file gc.c.

Referenced by Init_heap().

## ◆ obj_to_id_tbl

st_table* rb_objspace::obj_to_id_tbl

Definition at line 804 of file gc.c.

Referenced by Init_heap(), and rb_objspace_free().

## ◆ old_objects

size_t rb_objspace::old_objects

Definition at line 776 of file gc.c.

Referenced by rb_gc_force_recycle().

## ◆ old_objects_limit

size_t rb_objspace::old_objects_limit

Definition at line 777 of file gc.c.

## ◆ parent_object

VALUE rb_objspace::parent_object

Definition at line 771 of file gc.c.

## ◆

struct { ... } rb_objspace::profile

Referenced by Init_heap(), rb_gc_count(), rb_gc_force_recycle(), rb_gc_writebarrier_unprotect(), and rb_objspace_free().

## ◆ range

RVALUE* rb_objspace::range[2]

Definition at line 710 of file gc.c.

## ◆

struct { ... } rb_objspace::rcompactor

## ◆ read_barrier_faults

size_t rb_objspace::read_barrier_faults

Definition at line 736 of file gc.c.

## ◆ records

gc_profile_record* rb_objspace::records

Definition at line 723 of file gc.c.

Referenced by rb_objspace_free().

## ◆

struct { ... } rb_objspace::rgengc

Referenced by Init_heap(), rb_gc_force_recycle(), and ruby_gc_set_params().

## ◆ run

int rb_objspace::run

Definition at line 721 of file gc.c.

## ◆ size

size_t rb_objspace::size

Definition at line 726 of file gc.c.

## ◆ sorted

struct heap_page** rb_objspace::sorted

Definition at line 706 of file gc.c.

## ◆ sorted_length

size_t rb_objspace::sorted_length

Definition at line 709 of file gc.c.

## ◆ tomb_heap

rb_heap_t rb_objspace::tomb_heap

Definition at line 696 of file gc.c.

Referenced by rb_objspace_alloc().

## ◆ total_allocated_objects

size_t rb_objspace::total_allocated_objects

Definition at line 692 of file gc.c.

## ◆ total_allocated_objects_at_gc_start

size_t rb_objspace::total_allocated_objects_at_gc_start

Definition at line 757 of file gc.c.

## ◆ total_allocated_pages

size_t rb_objspace::total_allocated_pages

Definition at line 763 of file gc.c.

## ◆ total_freed_objects

size_t rb_objspace::total_freed_objects

Definition at line 762 of file gc.c.

Referenced by rb_gc_force_recycle().

## ◆ total_freed_pages

size_t rb_objspace::total_freed_pages

Definition at line 764 of file gc.c.

## ◆ total_moved

size_t rb_objspace::total_moved

Definition at line 793 of file gc.c.

## ◆ uncollectible_wb_unprotected_objects

size_t rb_objspace::uncollectible_wb_unprotected_objects

Definition at line 774 of file gc.c.

## ◆ uncollectible_wb_unprotected_objects_limit

size_t rb_objspace::uncollectible_wb_unprotected_objects_limit

Definition at line 775 of file gc.c.

The documentation for this struct was generated from the following file:

- gc.c